'change HANDLE -> HWND
'change HANDLE -> HINSTANCE in FormLoad
'added param types in Setcolor function
'bc728 will get a warning because it's FindFirstInstance use char * Application
'where bc9 uses const char *
' *************************************************************************
'       BCX Basic GUI Sample By Kevin Diggins -- December 2000
'                Demonstrates how to set and change
'  The Text Color, Background Color, And Fonts Used By Edit Controls
' *************************************************************************
'$ONEXIT "VSC.BAT $FILE$ -m64 gui"
'$ONEXIT "PEL.BAT $FILE$ -m64 gui"
GUI NOMAIN
$CPP
'$CPPHDR
'$ONEXIT "VSCPP.BAT $FILE$ -m64 gui"
$ONEXIT "TDMGPP.BAT $FILE$ -m64 gui"
'Declare Function zTrace Lib "ztrace64.dll" Alias "zTrace"(ws As const WCHAR Ptr) As LONG_PTR
'CONST ZPRINT(x)= zTrace(ANSITOWIDE(x,CP_ACP,MB_PRECOMPOSED))

SUB SetCustomFonts()
	GLOBAL MyFont1 AS HFONT
	GLOBAL MyFont2 AS HFONT
	MyFont1 = MakeFont ( "Arial",    10 )
	MyFont2 = MakeFont ( "Garamond", 10)
	SendMessage ( Edit1 , WM_SETFONT, MyFont1, TRUE )
	SendMessage ( Edit2 , WM_SETFONT, MyFont2, TRUE )
END SUB
'==============================================================================
FUNCTION MakeFont ( Font As const char ptr, PointSize ) AS HFONT
	LOCAL hDC AS HDC
	LOCAL CyPixels
	hDC = GetDC(HWND_DESKTOP)
	CyPixels  = GetDeviceCaps(hDC, LOGPIXELSY)
	ReleaseDC (HWND_DESKTOP, hDC )
	PointSize = (PointSize * CyPixels) / 72
	FUNCTION  = CreateFont(0-PointSize,0,0,0,FW_NORMAL,0,0,0,ANSI_CHARSET, _
	OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FF_DONTCARE, Font )
END FUNCTION
'==============================================================================
FUNCTION WinMain()
	LOCAL Wc  AS WNDCLASS
	LOCAL Msg AS MSG
	
	IF FINDFIRSTINSTANCE(AppName$) THEN EXIT FUNCTION
	Wc.style           = CS_HREDRAW OR CS_VREDRAW 
	Wc.lpfnWndProc     = WndProc
	Wc.cbClsExtra      = 0
	Wc.cbWndExtra      = 0
	Wc.hInstance       = hInst
	Wc.hIcon           = LoadIcon     ( NULL,IDI_WINLOGO )
	Wc.hCursor         = LoadCursor      ( NULL, IDC_ARROW )
	Wc.hbrBackground   = (HBRUSH)(COLOR_BTNFACE+1)
	Wc.lpszMenuName    = NULL
	Wc.lpszClassName   = AppName$
	
	RegisterClass(&Wc)
	
	FormLoad (hInst)
	
	WHILE GetMessage ( &Msg, NULL, 0 ,0 )
	'***************************************************************
	' The following test allows tabbing between controls on Form1
	'
	  IF NOT IsWindow(Form1) OR NOT IsDialogMessage(Form1,&Msg) THEN
	'***************************************************************
	    TranslateMessage ( &Msg )
	    DispatchMessage  ( &Msg )
	  END IF
	WEND
	FUNCTION = Msg.wParam
END FUNCTION
'==============================================================================
CALLBACK FUNCTION WndProc
	SELECT CASE Msg
	
	'***********************************************************************
	  CASE WM_CTLCOLOREDIT
	'***********************************************************************
	
	  If (HWND)lParam = Edit1 Then
	    Function =  SetColor (RGB(255,0,0),RGB(255,255,255),wParam,lParam)
	  End If
	
	  If (HWND) lParam = Edit2 Then
	    Function =  SetColor (RGB(0,255,0), RGB(0,0,0),wParam,lParam)
	  End If
	
	'***********************************************************************
	  CASE WM_CLOSE
	'***********************************************************************
	  LOCAL id
	
	  id = MessageBox(        _
	  hWnd,              _
	  "Are you sure?",    _
	  "Quit Program!",    _
	  MB_YESNO OR MB_ICONQUESTION )
	  IF id = IDYES THEN DestroyWindow (hWnd)
	  EXIT FUNCTION
	'***********************************************************************
	  CASE WM_DESTROY
	'***********************************************************************
	  DeleteObject ( ReUsableBrush )
	  PostQuitMessage(0)
	  EXIT FUNCTION
	'***********************************************************************
	END SELECT

END FUNCTION
'==============================================================================

SUB FormLoad ( hInst As HINSTANCE )
	'***********************************************************************
	CONST AppName$ = "ColorEdit"
	CONST Caption$ = "Edit Ctrl Colors and Fonts"
	'***********************************************************************
	GLOBAL BCX_GetDiaUnit
	GLOBAL BCX_cxBaseUnit
	GLOBAL BCX_cyBaseUnit
	'GLOBAL BCX_ScaleX
	'GLOBAL BCX_ScaleY
	'ZPRINT("Hello")
	'***********************************************************************
	'               Scale Dialog Units To Screen Units
	'***********************************************************************
	BCX_GetDiaUnit = GetDialogBaseUnits()
	BCX_cxBaseUnit = LOWORD(BCX_GetDiaUnit)
	BCX_cyBaseUnit = HIWORD(BCX_GetDiaUnit)
	BCX_ScaleX     = BCX_cxBaseUnit/4
	BCX_ScaleY     = BCX_cyBaseUnit/8
	'***********************************************************************
	Local As float fHeight,fWidth
	Dim t$
	fWidth = 165*BCX_ScaleX
	fHeight = (12+144)*BCX_ScaleY
	't$ = "fWidth = " & Str$(fWidth)
	'ZPRINT(t$)
	't$ = "fHeight = " + Str$(fHeight)
	'ZPRINT(t$)
	GLOBAL Form1 AS HWND
	
	Form1 = CreateWindow(AppName$,Caption$, _
	DS_MODALFRAME OR WS_POPUP OR WS_CAPTION OR WS_SYSMENU , _
    0,0,fWidth,fHeight, _'	0,0,165*BCX_ScaleX,(12+144)*BCX_ScaleY, _
	NULL,NULL,hInst,NULL)
	
	'***********************************************************************
	
	GLOBAL  Edit1 AS HWND
	CONST   ID_Edit1 = 101
	
	Edit1 = CreateWindow("edit",NULL, _
	WS_CHILD OR WS_VISIBLE OR WS_BORDER OR ES_AUTOVSCROLL OR ES_WANTRETURN  _
	OR ES_AUTOHSCROLL OR ES_MULTILINE, _
	7*BCX_ScaleX,8*BCX_ScaleY,150*BCX_ScaleX,55*BCX_ScaleY, _
	Form1,ID_Edit1,hInst,NULL)
	
	'***********************************************************************
	
	GLOBAL  Edit2 AS HWND
	CONST   ID_Edit2 = 102
	
	Edit2 = CreateWindow("edit",NULL, _
	WS_CHILD OR WS_VISIBLE OR WS_BORDER OR ES_AUTOVSCROLL OR ES_WANTRETURN  _
	OR ES_AUTOHSCROLL OR ES_MULTILINE, _
	7*BCX_ScaleX,79*BCX_ScaleY,150*BCX_ScaleX,58*BCX_ScaleY, _
	Form1,ID_Edit2,hInst,NULL)
	
	'***********************************************************************
	
	
	
	
	SetWindowText (Edit1, " Text in this control set to RED ON WHITE" )
	SetWindowText (Edit2, " Text in this control set to Green ON BLACK" )
	
	SetCustomFonts()
	SetFocus (Edit1)
	
	Center (Form1)                 ' Center our Form on the screen
	Show   (Form1)                 ' Display our creation!
	
END SUB
'==============================================================================
FUNCTION SetColor ( TxtColr As int , BkColr As int , wParam As WPARAM ,lParam AS LPARAM) AS LRESULT CALLBACK
	GLOBAL ReUsableBrush AS HBRUSH
	DeleteObject  ( ReUsableBrush )
	ReUsableBrush = CreateSolidBrush( BkColr )
	SetTextColor  ( (HDC)  wParam, TxtColr )
	SetBkColor    ( (HDC)  wParam, BkColr )
	Function  =   ( LRESULT ) ReUsableBrush
END FUNCTION
