// *********************************************************************
//  Created with bc9Basic - BASIC To C/C++ Translator (V) 9.2.4.8 (2016/03/21)
//       The bc9Basic translator (bc9.exe) was compiled with
//                           g++ (tdm64-1) 5.1.0
// ----------------------------------------------------------------------
//                 BCX (c) 1999 - 2009 by Kevin Diggins
// *********************************************************************
//              Translated for compiling with a C++ Compiler
//                           On MS Windows
// *********************************************************************
#include <windows.h>    // Win32 Header File 
#include <windowsx.h>   // Win32 Header File 
#include <commctrl.h>   // Win32 Header File 
#include <commdlg.h>    // Win32 Header File 
#include <mmsystem.h>   // Win32 Header File 
#include <shellapi.h>   // Win32 Header File 
#include <shlobj.h>     // Win32 Header File 
#include <richedit.h>   // Win32 Header File 
#include <objbase.h>    // Win32 Header File 
#include <ocidl.h>      // Win32 Header File 
#include <winuser.h>    // Win32 Header File 
#include <olectl.h>     // Win32 Header File 
#include <oaidl.h>      // Win32 Header File 
#include <ole2.h>       // Win32 Header File 
#include <oleauto.h>    // Win32 Header File 
#include <winsock.h>    // Win32 Header File 
#include <wininet.h>    // Win32 Header File 
#ifndef __TINYC__       // No Tiny C support
#include <urlmon.h>     // Win32 Header File 
#endif
#include <process.h>    // dos
#include <direct.h>     // dos
#include <io.h>         // dos
#include <conio.h>      // dos
#include <cwchar>      // c++ dos/linux 
#include <cctype>      // c++ dos/linux
#include <cmath>       // c++ dos/linux
#include <cstdio>      // c++ dos/linux
#include <cstring>     // c++ dos/linux
#include <cstddef>     // c++ dos/linux
#include <cstdlib>     // c++ dos/linux
#include <csetjmp>     // c++ dos/linux
#include <ctime>       // c++ dos/linux
#include <cstdarg>     // c++ dos/linux
#include <fcntl.h>      // dos/linux
#include <sys/types.h>
#include <sys/stat.h>


// ***************************************************
// Compiler Defines
// ***************************************************

// C++
#if defined( __cplusplus )
#define overloaded
#define C_EXPORT EXTERN_C __declspec(dllexport)
#define C_IMPORT EXTERN_C __declspec(dllimport)
#else
#define C_EXPORT __declspec(dllexport)
#define C_IMPORT __declspec(dllimport)
#endif


// Microsoft VC++
#ifndef DECLSPEC_UUID
#if (_MSC_VER >= 1100) && defined ( __cplusplus )
#define DECLSPEC_UUID(x)    __declspec(uuid(x))
#else
#define DECLSPEC_UUID(x)
#endif
#endif

#define stricmp _stricmp
#ifndef __cplusplus
#error A C++ compiler is required
#endif

// *************************************************
// Instruct Linker to Search Object/Import Libraries
// *************************************************
#pragma comment(lib,"kernel32.lib")
#pragma comment(lib,"user32.lib")
#pragma comment(lib,"gdi32.lib")
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"advapi32.lib")
#pragma comment(lib,"winspool.lib")
#pragma comment(lib,"shell32.lib")
#pragma comment(lib,"ole32.lib")
#pragma comment(lib,"oleaut32.lib")
#pragma comment(lib,"uuid.lib")
#pragma comment(lib,"odbc32.lib")
#pragma comment(lib,"odbccp32.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"comdlg32.lib")
#pragma comment(lib,"imagehlp.lib")
#pragma comment(lib,"version.lib")
#pragma comment(lib,"wininet.lib")
#pragma comment(lib,"urlmon.lib")
// *************************************************
// End of Object/Import Libraries To Search
// *************************************************

// *************************************************
//        User's GLOBAL ENUM blocks
// *************************************************

// *************************************************
//            System Defined Constants
// *************************************************

typedef const char* ccptr;
#define CCPTR const char*
#define cfree free
#define WAITKEY system("pause")
#define EQU ==
#define NOT_USED(x) if(x);
#define CTLHNDL(id) GetDlgItem(hWnd,id)
char   *g_cptr_;  // dummy var for not used returns
unsigned int  g_dum1_;  // dummy var for not used returns
#define cSizeOfDefaultString 2048

// *************************************************
//            User Defined Constants
// *************************************************

#define AppName "ColorEdit"
#define Caption "Edit Ctrl Colors and Fonts"
#define ID_Edit1 101
#define ID_Edit2 102

// *************************************************
//               Standard Prototypes
// *************************************************

void    Center (HWND, HWND = 0, HWND = 0);
BOOL    FindFirstInstance (const char*);
// *************************************************
//          User Defined Types, Unions and Classes
// *************************************************


// *************************************************
//            User Global Variables
// *************************************************

static HFONT   BcxFont;
static float   BCX_ScaleX;
static float   BCX_ScaleY;
static HINSTANCE BCX_hInstance;
static HWND    BCX_hwndMDIClient;
static WNDCLASSEX BCX_WndClass;
static BOOL    BCX_GUI_Init;
static char    BCX_ClassName[cSizeOfDefaultString];
static HFONT   MyFont1;
static HFONT   MyFont2;
static int     BCX_GetDiaUnit;
static int     BCX_cxBaseUnit;
static int     BCX_cyBaseUnit;
static HWND    Form1;
static HWND    Edit1;
static HWND    Edit2;
static HBRUSH  ReUsableBrush;


// *************************************************
//               Standard Macros
// *************************************************

#define BOR |
#define Show(Window)RedrawWindow(Window,0,0,0);ShowWindow(Window,SW_SHOW);


// *************************************************
//               User Prototypes
// *************************************************

void    SetCustomFonts (void);
HFONT   MakeFont (const char* , int);
int     WINAPI WinMain (HINSTANCE, HINSTANCE, LPSTR, int);
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);
void    FormLoad (HINSTANCE);
LRESULT CALLBACK SetColor (int, int, WPARAM, LPARAM);

// *************************************************
//            User Global Initialized Arrays
// *************************************************



// *************************************************
//                 Runtime Functions
// *************************************************

BOOL FindFirstInstance (const char *Application)
{
    HWND  hWnd;
    char EventName[cSizeOfDefaultString];
    hWnd = FindWindow(Application, NULL);
    if(hWnd)
    {
        if(IsIconic(hWnd))
        {
            strcpy(EventName, Application);
            strcat(EventName, "_EnFI");
            CreateMutex(NULL, TRUE, EventName);
            if(GetLastError() == ERROR_ALREADY_EXISTS)
            {
                return TRUE;
            }
            DWORD  dwVersion;
            int    IsNT = {0};
            dwVersion = GetVersion();
            if(dwVersion < 0x80000000 && (DWORD)(LOBYTE(LOWORD(dwVersion))) >= 5)
            {
                IsNT = 1;
            }
            while(GetForegroundWindow() != hWnd)
            {
                FlashWindow(hWnd, TRUE);
                Sleep(450);
                if(IsNT == 1)
                {
                    FlashWindow(hWnd, FALSE);
                }
            }
        }
        SetForegroundWindow(hWnd);
        return TRUE;
    }
    return FALSE;
}


void Center (HWND hwnd, HWND Xhwnd, HWND Yhwnd)
{
    RECT rect, rectP;
    int  x, y, width, height;
    int  screenwidth, screenheight;
    if(Xhwnd == 0)
    {
        RECT  DesktopArea;
        RECT  rc;
        SystemParametersInfo(SPI_GETWORKAREA, 0, &DesktopArea, 0);
        GetWindowRect(hwnd, &rc);
        SetWindowPos(hwnd, HWND_TOP,
                     ((DesktopArea.right - DesktopArea.left) - (rc.right - rc.left)) / 2 +
                     DesktopArea.left, ((DesktopArea.bottom - DesktopArea.top) -
                                        (rc.bottom - rc.top)) / 2 + DesktopArea.top, 0, 0, SWP_NOSIZE);
        return;
    }
    GetWindowRect (hwnd, &rect);
    GetWindowRect (Xhwnd, &rectP);
    width = rect.right - rect.left;
    x = ((rectP.right - rectP.left) - width) / 2 + rectP.left;
    if(Yhwnd == NULL)
    {
        height = rect.bottom - rect.top;
        y = ((rectP.bottom - rectP.top) - height) / 2 + rectP.top;
    }
    else
    {
        GetWindowRect(Yhwnd, &rectP);
        height = rect.bottom - rect.top;
        y = ((rectP.bottom - rectP.top) - height) / 2 + rectP.top;
    }
    screenwidth = GetSystemMetrics(SM_CXSCREEN);
    screenheight = GetSystemMetrics(SM_CYSCREEN);
    if ((x < 0)) x = 0;
    if ((y < 0)) y = 0;
    if ((x + width > screenwidth))   x = screenwidth - width;
    if ((y + height > screenheight)) y = screenheight - height;
    MoveWindow (hwnd, x, y, width, height, FALSE);
}



// *************************************************
//       User Subs, Functions and Class Methods
// *************************************************

void SetCustomFonts ()
{
    MyFont1 = MakeFont("Arial", 10);
    MyFont2 = MakeFont("Garamond", 10);
    SendMessage(Edit1, (UINT)WM_SETFONT, (WPARAM)MyFont1, (LPARAM)TRUE);
    SendMessage(Edit2, (UINT)WM_SETFONT, (WPARAM)MyFont2, (LPARAM)TRUE);
}


HFONT MakeFont (const char*  Font, int PointSize)
{
    HDC      hDC = {0};
    int     CyPixels = {0};
    hDC = GetDC( HWND_DESKTOP);
    CyPixels = GetDeviceCaps( hDC, LOGPIXELSY);
    ReleaseDC(HWND_DESKTOP, hDC);
    PointSize = ( PointSize * CyPixels) / 72;
    return CreateFont(0 - PointSize, 0, 0, 0, FW_NORMAL, 0, 0, 0, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_DONTCARE, Font);
}


int WINAPI WinMain (HINSTANCE  hInst, HINSTANCE  hPrev, LPSTR  CmdLine, int CmdShow)
{
    WNDCLASS  Wc = {0};
    MSG      Msg = {0};
    if(FindFirstInstance(AppName))
    {
        return 0;
    }
    Wc.style = CS_HREDRAW  BOR  CS_VREDRAW;
    Wc.lpfnWndProc = WndProc;
    Wc.cbClsExtra = 0;
    Wc.cbWndExtra = 0;
    Wc.hInstance = hInst;
    Wc.hIcon = LoadIcon( NULL, IDI_WINLOGO);
    Wc.hCursor = LoadCursor( NULL, IDC_ARROW);
    Wc.hbrBackground = ( HBRUSH)( COLOR_BTNFACE + 1);
    Wc.lpszMenuName = NULL;
    Wc.lpszClassName = AppName;
    RegisterClass( &Wc);
    FormLoad(hInst);
    while(GetMessage( &Msg, NULL, 0, 0))
    {
        if(!IsWindow(Form1) || !IsDialogMessage(Form1, &Msg))
        {
            TranslateMessage( &Msg);
            DispatchMessage( &Msg);
        }
    }

    return Msg.wParam;
}


LRESULT CALLBACK WndProc (HWND hWnd, UINT Msg, WPARAM  wParam, LPARAM  lParam)
{
    if(Msg == WM_CTLCOLOREDIT )
    {
        if((HWND)lParam == Edit1 )
        {
            return SetColor(RGB(255, 0, 0), RGB(255, 255, 255), wParam, lParam);
        }
        if((HWND)lParam == Edit2 )
        {
            return SetColor(RGB(0, 255, 0), RGB(0, 0, 0), wParam, lParam);
        }
        goto L1001;
    }
    if(Msg == WM_CLOSE )
    {
        int     id = {0};
        id = MessageBox( hWnd, "Are you sure?", "Quit Program!", MB_YESNO  BOR  MB_ICONQUESTION);
        if(id == IDYES )
        {
            DestroyWindow(hWnd);
        }
        return 0;
    }
    if(Msg == WM_DESTROY )
    {
        DeleteObject(ReUsableBrush);
        PostQuitMessage(0);
        return 0;
    }
L1001:
    ;
    return DefWindowProc(hWnd, Msg, wParam, lParam);
}


void FormLoad (HINSTANCE  hInst)
{
    BCX_GetDiaUnit = GetDialogBaseUnits();
    BCX_cxBaseUnit = LOWORD( BCX_GetDiaUnit);
    BCX_cyBaseUnit = HIWORD( BCX_GetDiaUnit);
    BCX_ScaleX = BCX_cxBaseUnit / 4;
    BCX_ScaleY = BCX_cyBaseUnit / 8;
    float    fHeight = {0};
    float    fWidth = {0};
    char    t[cSizeOfDefaultString] = {0};
    fWidth = 165 * BCX_ScaleX;
    fHeight = ( 12 + 144) * BCX_ScaleY;
    Form1 = CreateWindow( AppName, Caption, DS_MODALFRAME  BOR  WS_POPUP  BOR  WS_CAPTION  BOR  WS_SYSMENU, 0, 0, fWidth, fHeight, NULL, (HMENU) NULL, hInst, NULL);
    Edit1 = CreateWindow("edit", NULL, WS_CHILD  BOR  WS_VISIBLE  BOR  WS_BORDER  BOR  ES_AUTOVSCROLL  BOR  ES_WANTRETURN  BOR  ES_AUTOHSCROLL  BOR  ES_MULTILINE, 7 * BCX_ScaleX, 8 * BCX_ScaleY, 150 * BCX_ScaleX, 55 * BCX_ScaleY, Form1, (HMENU) ID_Edit1, hInst, NULL);
    Edit2 = CreateWindow("edit", NULL, WS_CHILD  BOR  WS_VISIBLE  BOR  WS_BORDER  BOR  ES_AUTOVSCROLL  BOR  ES_WANTRETURN  BOR  ES_AUTOHSCROLL  BOR  ES_MULTILINE, 7 * BCX_ScaleX, 79 * BCX_ScaleY, 150 * BCX_ScaleX, 58 * BCX_ScaleY, Form1, (HMENU) ID_Edit2, hInst, NULL);
    SetWindowText(Edit1, " Text in this control set to RED ON WHITE");
    SetWindowText(Edit2, " Text in this control set to Green ON BLACK");
    SetCustomFonts();
    SetFocus(Edit1);
    Center(Form1);
    Show(Form1);
}


LRESULT CALLBACK SetColor (int TxtColr, int BkColr, WPARAM  wParam, LPARAM  lParam)
{
    DeleteObject(ReUsableBrush);
    ReUsableBrush = CreateSolidBrush( BkColr);
    SetTextColor((HDC)wParam, TxtColr);
    SetBkColor((HDC)wParam, BkColr);
    return (LRESULT)ReUsableBrush;
}



